/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/index.php?title=User:Seb76> for more details.
 * Copyright (C) 2008,2009 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "music.h"
#include "patcher.h"
#include "xcom.h"

typedef struct file_s
{
	struct file_s *next;
	const char *name;
} file_t;

typedef struct
{
	file_t *head;
	file_t *current;
} file_list;

static file_list *fileLists[19];

static void addFile(file_list *list, const char *name)
{
	for(file_t *file = list->head; file!=NULL; file=file->next)
	{
		if(!stricmp(name, file->name))
			return;
	}

	file_t *file = (file_t *)malloc(sizeof(file_t));
	file->next = list->head;
	file->name = strdup(name);

	if(list->head == NULL)
		list->current = file;

	list->head = file;
}

static file_t *getNextFile(file_list *list)
{
	file_t *ret = list->current;
	if(list->current != NULL)
	{
		list->current = list->current->next;

		if(list->current == NULL)
			list->current = list->head;
	}
	return ret;
}

static void addFilesToList(file_list *list, const char *pattern)
{
	WIN32_FIND_DATAA FindFileData;
	HANDLE hFind;
	char path[MAX_PATH];
	INI_READ_STRING("Music","MP3 Folder","mp3",path,MAX_PATH);
	strcat(path,"/");
	strcat(path,pattern);

	hFind = FindFirstFileA(path, &FindFileData);
	if (hFind == INVALID_HANDLE_VALUE) 
	{
		return;
	} 

	addFile(list,FindFileData.cFileName);

	while(FindNextFileA(hFind, &FindFileData))
	{
		addFile(list,FindFileData.cFileName);
	}

	FindClose(hFind);
}

static file_list *getNewList(const char *listName)
{
	char patternList[2048];
	INI_READ_STRING("Music",listName,"",patternList,2047);

	file_list *ret = (file_list *)malloc(sizeof(file_list));
	ret->current = NULL;
	ret->head = NULL;

	char *pattern = strtok (patternList,";");
	while (pattern != NULL)
	{
		addFilesToList(ret, pattern);
		pattern = strtok (NULL, ";");
	}

	return ret;
}

#define MCI_QUEUE_SIZE 4
static char mciString[MCI_QUEUE_SIZE][256];
static HWND mciHwnd[MCI_QUEUE_SIZE];
static int msgRead=0;
static int msgWrite=0;
static HANDLE mciSemaphoreRead;
static HANDLE mciSemaphoreWrite;

static MCIERROR WINAPI myMciSendString(LPCSTR lpszCommand, LPSTR lpszReturnString, UINT cchReturn, HWND hwndCallback)
{
	WaitForSingleObject(mciSemaphoreWrite,INFINITE);
	strcpy(mciString[msgWrite],lpszCommand);
	mciHwnd[msgWrite]=hwndCallback;
	msgWrite=(msgWrite+1)%MCI_QUEUE_SIZE;
	ReleaseSemaphore(mciSemaphoreRead,1,NULL);
	//Must put that here or there is no music!
	Sleep(10);
	return 0;
}

static DWORD WINAPI MusicThread(LPVOID lpThreadParameter)
{
	while(true)
	{
		WaitForSingleObject(mciSemaphoreRead,INFINITE);
		mciSendStringA(mciString[msgRead],0,0,mciHwnd[msgRead]);
		msgRead=(msgRead+1)%MCI_QUEUE_SIZE;
		ReleaseSemaphore(mciSemaphoreWrite,1,NULL);
	}
}

void ClickPauseBug()
{
	mciSemaphoreRead=CreateSemaphore(NULL,0,1,NULL);
	mciSemaphoreWrite=CreateSemaphore(NULL,MCI_QUEUE_SIZE,1,NULL);
	CreateThread(NULL,0,MusicThread,NULL,0,NULL);

	DWORD toto=(DWORD)&myMciSendString;
	PatchInPlace(0x469160,&toto,4);
}

void PlayMP3MusicFile(const char *filename)
{
	char buf[256];
	char path[MAX_PATH];
	HWND hWnd = *(HWND *)0x479B60;
	INI_READ_STRING("Music","MP3 Folder","mp3",path,MAX_PATH);

	sprintf(buf,"open \"%s/%s\" type mpegvideo alias MUSIC",path,filename);
	mciSendStringA("close MUSIC",NULL,0,NULL);
	mciSendStringA(buf,NULL,0,NULL);
	mciSendStringA("play MUSIC notify",NULL,0,hWnd);
}

void PlayMP3Music()
{
	int id=*CurrentMidiPlaying-0x80;

	file_list *list = fileLists[id];
	if(list != NULL)
	{
		file_t *file = getNextFile(list);
		if(file != NULL)
			PlayMP3MusicFile(file->name);
	}
}

void StopMP3Music()
{
	mciSendStringA("stop MUSIC",NULL,0,NULL);
	mciSendStringA("close MUSIC",NULL,0,NULL);
}

/*
13: tactical music
12: start menu
10: game over - failure
11: game won
0, 18: geoscape music
2: interception
9: mission score
3: ufo assault
6: xcom base defense
4: alien base assault
8: mars stage1 & 2
7: terror site
*/

void PlayCDMusicTrack(int track)
{
	static char open_cmd[256];
	static int init=0;
	char buf[256];

	if(!init)
	{
		init=1;
		INI_READ_STRING("Music","CD Drive","F",buf,2);
		sprintf(open_cmd,"open %s:\\ type cdaudio alias MUSIC wait",buf);
	}

	mciSendStringA("close MUSIC",NULL,0,NULL);
	mciSendStringA(open_cmd,NULL,0,NULL);
	mciSendStringA("set MUSIC time format tmsf wait",NULL,0,NULL);
	sprintf(buf,"play MUSIC from %d notify",track);

	mciSendStringA(buf,NULL,0,NULL);
}
/*
PSX tracks mapping details:
-1,2,3,4: geoscape
-5: gmdefend
-6: gmenbase
-7: gmmars
-8: gminter
-9: gmstory
-10,11: battlescape
-12: gmnewmar

gmwin and gmlose are not available. Because of similarity, gmlose is replaced with gmstory
and gmwin with gminter
*/

void PlayCDMusic()
{
	static int geo_track=1;
	static int tac_track=10;
	int id=*CurrentMidiPlaying-0x80;
	int track=0;

	switch(id) {
		//Geoscape music 1/2. Modify to play the 4 first tracks of the CD repeatedly
		case 0:
		case 18:
			track=geo_track;
			geo_track=geo_track+1;
			if(geo_track==5)
				geo_track=1;
			break;
		//Interception
		case 2:
			track=8;
			break;
		//GMDEFEND?
		case 3:
		case 4:
			track=5;
			break;
		//GMENBASE
		case 6:
		case 7:
			track=6;
			break;
		//GMMARS
		case 8:
			track=7;
			break;
		//GMLOSE
		case 10:
			track=9;
			break;
		//GMWIN
		case 11:
			track=8;
			break;
		//GMSTORY
		case 9:
		case 12:
			track=9;
			break;
		//GMTACTIC
		case 13:
			track=tac_track;
			tac_track^=1;
			break;
		//No corresponding music on CE edition
		default:
		case 1:
		case 5:
		case 14:
		case 15:
		case 16:
		case 17:
			return;
	}

	//Tracks are off by one because of the data track
	track++;
	PlayCDMusicTrack(track);
}

void StopCDMusic()
{
	static char open_cmd[64];
	static int init=0;

	if(!init)
	{
		char buf[3];
		init=1;
		INI_READ_STRING("Music","CD Drive","F",buf,2);
		sprintf(open_cmd,"open %s:\\ type cdaudio alias MUSIC wait",buf);
	}

	mciSendStringA(open_cmd,NULL,0,NULL);
	mciSendStringA("stop MUSIC",NULL,0,NULL);
	mciSendStringA("close MUSIC",NULL,0,NULL);
}

void ModMusic()
{
	//mov CurrentMidiPlaying, esi
	//pop edi
	//pop esi

	char patch_music[]={ 0x89, 0x35, 0xE8, 0x58, 0x47, 0x00, 0x5F, 0x5E };
	PatchInPlace(0x45D991,patch_music,8);

	char buf[16];
	INI_READ_STRING("Music","Source","CD",buf,15);
	
	if(!stricmp(buf,"PSX CD"))
	{
		InsertJmp(0x45D991+8,PlayCDMusic);
		InsertJmp(0x45C7A5,StopCDMusic);
	}
	else if(!stricmp(buf,"MP3"))
	{
		InsertJmp(0x45D991+8,PlayMP3Music);
		InsertJmp(0x45C7A5,StopMP3Music);

		memset(fileLists,0,sizeof(fileLists));

		fileLists[13] = getNewList("Battlescape");
		fileLists[12] = getNewList("Start Menu");
		fileLists[10] = getNewList("Bad Ending");
		fileLists[11] = getNewList("Good Ending");
		fileLists[ 0] = getNewList("Geoscape");
		fileLists[18] = fileLists[ 0];
		fileLists[ 2] = getNewList("Dogfight");
		fileLists[ 9] = getNewList("Mission Debriefing");
		fileLists[ 3] = getNewList("UFO Assault");
		fileLists[ 6] = getNewList("Base Defense");
		fileLists[ 4] = getNewList("Base Attack");
		fileLists[ 8] = getNewList("Mars");
		fileLists[ 7] = getNewList("Terror Mission");
	}
}
